#ifndef FILE_LIST_H

#define FILE_LIST_H

//	TutH_[܂߂t@C̈ꗗєrERs[T|[g
//	2014/06/22

#include <windows.h>
#include <stdio.h>
#include <tchar.h>
#include <shlobj.h>
#include <time.h>
#include "list.hpp"


// t@CRs[ɌĂяo֐̒`
typedef DWORD (CALLBACK  *CpyProgFunc)(LARGE_INTEGER ,  LARGE_INTEGER ,  LARGE_INTEGER ,   LARGE_INTEGER ,  DWORD , DWORD , HANDLE , HANDLE , LPVOID  );


//	t@C̏ۑ\

struct FILE_LINK{
	friend struct FILE_LIST;
	TCHAR* name;			//	t@C
	FILE_LINK* next;	//	̃t@Cւ̃|C^
	FILE_LIST* child;	//	`ChtH_[

	FILETIME ftCreationTime;	// 쐬 [J^C
    FILETIME ftLastAccessTime;	// ŏIANZX [J^C
    FILETIME ftLastWriteTime;	// ŏIXV [J^C
	UINT64 FileSize;	//	t@CTCY
	DWORD Attr;	//	t@C
	void* userP;		//	[U[pf[^[ۑp
	UINT32 userD;

	FILE_LINK(){
		name = 0;
		next = 0;
		child = 0;
		userP = 0;
		userD = 0;
	}
	FILE_LINK& operator=(WIN32_FIND_DATA& src){
		Attr=src.dwFileAttributes;
		FileSize=(((UINT64)src.nFileSizeHigh)<<32)+src.nFileSizeLow;
		FileTimeToLocalFileTime(&src.ftCreationTime,&ftCreationTime);
		FileTimeToLocalFileTime( &src.ftLastAccessTime,&ftLastAccessTime);
		FileTimeToLocalFileTime( &src.ftLastWriteTime,&ftLastWriteTime);
		return *this;
	}
	INT64 data_cmp(FILE_LINK& src){	//	XV̔r
		INT64 d_dtc=*(INT64*)&ftLastWriteTime;
		INT64 d_src=*(INT64*)&src.ftLastWriteTime;
		INT64 a=d_dtc-d_src;
		return a;
	}
	void listview_header(HWND hList){
		LV_COLUMN lvcol;
		lvcol.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
            lvcol.fmt = LVCFMT_LEFT;
            lvcol.cx = 128;
            lvcol.pszText = TEXT("O");
            lvcol.iSubItem = 0;
            ListView_InsertColumn(hList, 0, &lvcol);

            lvcol.cx = 48;
            lvcol.fmt = LVCFMT_RIGHT;
			lvcol.pszText = TEXT("TCY");
            lvcol.iSubItem = 1;
            ListView_InsertColumn(hList, 1, &lvcol);

            lvcol.cx = 128;
            lvcol.fmt = LVCFMT_LEFT;
            lvcol.pszText = TEXT("XVt");
            lvcol.iSubItem = 2;
            ListView_InsertColumn(hList, 2, &lvcol);

            lvcol.cx = 128;
            lvcol.pszText = TEXT("ANZXt");
            lvcol.iSubItem = 3;
            ListView_InsertColumn(hList, 3, &lvcol);

			lvcol.cx = 128;
            lvcol.pszText = TEXT("쐬t");
            lvcol.iSubItem = 4;
            ListView_InsertColumn(hList, 4, &lvcol);

	}
	void listview_header2(HWND hList){	
		LV_COLUMN lvcol;
		lvcol.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
            lvcol.fmt = LVCFMT_LEFT;
            lvcol.cx = 128;
            lvcol.pszText = TEXT("O");
            lvcol.iSubItem = 0;
            ListView_InsertColumn(hList, 0, &lvcol);

            lvcol.cx = 48;
            lvcol.fmt = LVCFMT_RIGHT;
			lvcol.pszText = TEXT("TCY");
            lvcol.iSubItem = 1;
            ListView_InsertColumn(hList, 1, &lvcol);


            lvcol.cx = 128;
            lvcol.fmt = LVCFMT_LEFT;
            lvcol.pszText = TEXT("srcXVt");
            lvcol.iSubItem = 2;
            ListView_InsertColumn(hList, 2, &lvcol);

            lvcol.cx = 128;
            lvcol.pszText = TEXT("dtcXVt");
            lvcol.iSubItem = 3;
            ListView_InsertColumn(hList, 3, &lvcol);

            lvcol.cx = 128;
            lvcol.pszText = TEXT("tH_[");
            lvcol.iSubItem = 4;
            ListView_InsertColumn(hList, 4, &lvcol);
	}
	void listview_add2(HWND hList,int i,TCHAR* pass){
		TCHAR buf[64];
		LV_ITEM item;
		SYSTEMTIME st;

		item.mask = LVIF_TEXT  | LVIF_PARAM;
        item.pszText =name;
        item.iItem = i;
        item.iSubItem = 0;
	    item.lParam = i;
        ListView_InsertItem(hList, &item);

		_stprintf_s(buf,sizeof(buf)/sizeof(TCHAR),_TEXT("%li"),FileSize);
        item.mask = LVIF_TEXT;
		item.pszText = buf;
        item.iItem = i;
        item.iSubItem = 1;
        ListView_SetItem(hList, &item);

		FileTimeToSystemTime(&ftLastWriteTime,&st);	//	FILETIMESYSTEMTIMEɕϊ
		_stprintf_s(buf,sizeof(buf)/sizeof(TCHAR),_TEXT("%.4i/%.2i/%.2i %.2i:%.2i:%.2i"),(int)st.wYear,(int)st.wMonth,(int)st.wDay,(int)st.wHour,(int)st.wMinute,(int)st.wSecond);
        item.mask = LVIF_TEXT;
		item.pszText = buf;
        item.iItem = i;
        item.iSubItem = 2;
        ListView_SetItem(hList, &item);

		if(userP){
			FILE_LINK* dtc=(FILE_LINK*)userP;
			FileTimeToSystemTime(&dtc->ftLastWriteTime,&st);	//	FILETIMESYSTEMTIMEɕϊ
			_stprintf_s(buf,sizeof(buf)/sizeof(TCHAR),_TEXT("%.4i/%.2i/%.2i %.2i:%.2i:%.2i"),(int)st.wYear,(int)st.wMonth,(int)st.wDay,(int)st.wHour,(int)st.wMinute,(int)st.wSecond);
			item.mask = LVIF_TEXT;
			item.pszText = buf;
			item.iItem = i;
			item.iSubItem = 3;
			ListView_SetItem(hList, &item);
		}
		item.mask = LVIF_TEXT;
		item.pszText = pass;
		item.iItem = i;
		item.iSubItem = 4;
		ListView_SetItem(hList, &item);

	}
	void listview_add(HWND hList,int i){
		TCHAR buf[64];
		LV_ITEM item;
		SYSTEMTIME st;

		item.mask = LVIF_TEXT  | LVIF_PARAM;
        item.pszText =name;
        item.iItem = i;
        item.iSubItem = 0;
	    item.lParam = i;
        ListView_InsertItem(hList, &item);

		_stprintf_s(buf,sizeof(buf)/sizeof(TCHAR),_TEXT("%li"),FileSize);
        item.mask = LVIF_TEXT;
		item.pszText = buf;
        item.iItem = i;
        item.iSubItem = 1;
        ListView_SetItem(hList, &item);

		FileTimeToSystemTime(&ftLastWriteTime,&st);	//	FILETIMESYSTEMTIMEɕϊ
		_stprintf_s(buf,sizeof(buf)/sizeof(TCHAR),_TEXT("%.4i/%.2i/%.2i %.2i:%.2i:%.2i"),(int)st.wYear,(int)st.wMonth,(int)st.wDay,(int)st.wHour,(int)st.wMinute,(int)st.wSecond);
        item.mask = LVIF_TEXT;
		item.pszText = buf;
        item.iItem = i;
        item.iSubItem = 2;
        ListView_SetItem(hList, &item);


		FileTimeToSystemTime(&ftLastAccessTime,&st);	//	FILETIMESYSTEMTIMEɕϊ
		_stprintf_s(buf,sizeof(buf)/sizeof(TCHAR),_TEXT("%.4i/%.2i/%.2i %.2i:%.2i:%.2i"),(int)st.wYear,(int)st.wMonth,(int)st.wDay,(int)st.wHour,(int)st.wMinute,(int)st.wSecond);
        item.mask = LVIF_TEXT;
		item.pszText = buf;
        item.iItem = i;
        item.iSubItem = 3;
        ListView_SetItem(hList, &item);

		FileTimeToSystemTime(&ftCreationTime,&st);	//	FILETIMESYSTEMTIMEɕϊ
		_stprintf_s(buf,sizeof(buf)/sizeof(TCHAR),_TEXT("%.4i/%.2i/%.2i %.2i:%.2i:%.2i"),(int)st.wYear,(int)st.wMonth,(int)st.wDay,(int)st.wHour,(int)st.wMinute,(int)st.wSecond);
        item.mask = LVIF_TEXT;
		item.pszText = buf;
        item.iItem = i;
        item.iSubItem = 4;
        ListView_SetItem(hList, &item);
	}
};

//	t@CRs[ɏ󋵂ۑ\

struct CpyData{
	LONGLONG TotalFileSize;	//	Rs[ꂽoCg
	LONGLONG TotalBytesTransferred;	//	t@CTCY
	
	LONGLONG AllTotalFileSize;	//	St@C̃TCY
	LONGLONG AllTotalBytesTransferred;	//	St@CTCY
	LONGLONG reTotalBytesTransferred;	//	OĂяõRs[ꂽt@C̃oCg

	TCHAR* src;	//	Rs[t@C
	TCHAR* dtc;	//	Rs[t@C	
	TCHAR* pass;	//	Rs[t@C srcdtcŋʂȖ̕
	TCHAR* fname;	//	Rs[t@C tH_[܂܂Ȃ
	clock_t	start;	//	Rs[JnꂽƂ̎
	clock_t	file_start;	//	t@CύXꂽƂ̊Jn

	int	AllNum;	//	St@Č
	int num;	//	Rs[ꂽt@Č
};



//	t@CǗ\

struct FILE_LIST : public LIST{
	TCHAR* name;	//	etH_[
	long long	file_size;	//	t@C̍vTCY
	FILE_LIST* parent;	//	etH_[FILE_LIST
	int file_num;	//	t@C
	int dir_num;	//	tH_[

	FILE_LIST() : LIST() {
		name = 0;
		parent = 0;
		file_num=dir_num=0;
		file_size=0;
	}
	LINK* append(FILE_LINK* p){	//	t@Cǉ
		return LIST::append((void*)p);
	}
	FILE_LINK* next(void){	//	̃t@C	
		return (FILE_LINK*)LIST::next();
	}
	FILE_LINK* first(void){	//	ŏ̃t@C
		return (FILE_LINK*)LIST::first();
	}
	int find(TCHAR* pass, int sz, TCHAR* card);	// passŎtH_[cardŎ郏CJ[hɍvt@CFILE_LISTɓo^
	FILE_LINK* dupchk(TCHAR* fullpass);	// fullpassFILE_LISTɓo^Ă邩
	void short_puts(TCHAR* pass, int num);	// t@C̈ꗗWo͂ɏo͂BtH_[KwƂɃCfgB
	void put_listview(HWND hList,int* num);
	void put_listview2(HWND hList,int* num,TCHAR* pass,int sz);
	void full_rename(TCHAR* pass, int num); // tH_[Et@CSp甼pɕϊ
	void put_treeview(HWND hWnd,HTREEITEM t); // tH_[Et@CSp甼pɕϊ
	int cmp(FILE_LIST& dtc,FILE_LIST& src);	//	tH_[dtcsrcr(dtcXVKv)thisɍ쐬B
	void cpy(FILE_LIST& src);

	FILE_LINK* find_name(TCHAR* name){	//	`ChtH_[܂܂v閼OFILE_LINK*ԂB
		FILE_LINK* p = first();
		while (p){
			if (_tcscmp(name, p->name) == 0){
				return p;
			}
			p = next();
		}
		return 0;
	}

	void clear(void){	//	FILE_LISTɓo^ĂtH_[Et@CNAB
		FILE_LINK* p = first();
		FILE_LINK* np;
		while (p){
			np = next();
			if (p->child){
				p->child->clear();
			}
			delete p->name;
			delete p;
			p = np;
		}
		LIST::all_del();
	}
	//	t@CEtH_[Ԃ
	void info(int* AllFile,int* NewFile,int* AllDir,int* NewDir);
	//	t@CEtH_[̍폜
	void del_file(TCHAR* pass,int sz);
	//	t@CEtH_[̃Rs[
	void copy_file(TCHAR* dtc_pass,int dtc_sz,TCHAR* src_pass,int src_sz,LPPROGRESS_ROUTINE func=0, CpyData* cpy=0, LPBOOL pbCancel=FALSE, DWORD dwCopyFlags=0);
};

#endif
